<?php

include('.diesel');

diesel_force_login();

// ACTIONS

function message($theMessage)
{
 echo '<p class="action-message">'.$theMessage.'</p>';
}

function create_table()
{
 $query =
 <<<MySQL
   CREATE TABLE `distrib_list` (
    `id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
    `nom` CHAR( 32 ) NOT NULL ,
    `courriel` CHAR( 127 ) NOT NULL ,
    `categorie` ENUM( 'lve', 'parent d\'lve', 'journaliste', 'partenaire', 'autre' ) NOT NULL,
    `commentaires` TEXT,
    `adresse` CHAR( 64 ),
    `ville` CHAR( 32 ),
    `province` CHAR( 16 ),
    `pays` CHAR( 32 ),
    `codepostal` CHAR( 10 ),
    `telephone` CHAR( 16 ),
    `poste` CHAR( 5 ),
    `cellulaire` CHAR( 16 ),
    `teleavertisseur` CHAR( 16 ),
    `autretelephone` CHAR( 16 ),
    `telecopieur` CHAR( 16 ),
    `siteweb` CHAR( 127 ),
    `created` DATETIME,
    PRIMARY KEY ( `id` ) ) COMMENT = 'Liste de distribution';
MySQL;
 if (diesel_db_query($query))
  message('Table <i>distrib_list</i> cre avec succs');
 else
  message('Impossible de crer la table <i>distrib_list</i>');
}

function action_delete()
{
 $requete = 'DELETE FROM distrib_list WHERE ';
 foreach ($_POST['id'] as $id) $requete .= 'id='.$id.' OR ';
 $requete .= '1=0';
 $result = diesel_db_query($requete);
 if (!$result)
  message('Erreur lors de la commande <i>delete</i><br>'.mysql_error());
}

function action_export()
{
 if(!isset($_POST['format']))
  $format="csv";
 else
  $format=$_POST['format'];
 
 switch ($format)
 {
  case 'csv':
  case 'csv_outlook':
   $requete = 'SELECT * FROM distrib_list WHERE ';
   foreach ($_POST['id'] as $id) $requete .= 'id='.$id.' OR ';
   $requete .= '1=0 ORDER BY nom';
   $result = diesel_db_query($requete);
   if (!$result)
    message('ERREUR: '.mysql_error());
   else 
   {
    header('Content-type: text/csv');
    header('Content-Disposition: attachment; filename="cbdanse'.date('Y-m-d').'.csv"');
    header('Content-Description: Liste d\'envoi Christiane Blanger-Danse');
 //   header('Content-Transfer-Encoding: binary');
 
    if ($format=='csv_outlook')
     echo 'Nom;Adresse de messagerie;Catgorie;Remarques;Rue (domicile);Ville (domicile);Dpartement (domicile);Pays/rgion (domicile);Code Postal (domicile);Tlphone personnel;Service;Tlphone mobile;Radiomessagerie;Tlphone professionnel;Tlcopie personnelle;Page Web (domicile);created';
    else
     echo 'nom,courriel,categorie,commentaires,adresse,ville,province,pays,codepostal,telephone,poste,cellulaire,teleavertisseur,autretelephone,telecopieur,siteweb,created';
 
    while ($item=mysql_fetch_object($result))
     if ($format=='csv_outlook') echo br.
         str_replace(br,'_',str_replace(';','_',$item->nom)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->courriel)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->categorie)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->commentaires)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->adresse)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->ville)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->province)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->pays)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->codepostal)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->telephone)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->poste)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->cellulaire)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->teleavertisseur)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->autretelephone)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->telecopieur)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->siteweb)).';'.
     	 str_replace(br,'_',str_replace(';','_',$item->created));
      else echo '
 "'.sqlsafe($item->nom).'",'.
     	 '"'.sqlsafe($item->courriel).'",'.
     	 '"'.sqlsafe($item->categorie).'",'.
     	 '"'.sqlsafe($item->commentaires).'",'.
     	 '"'.sqlsafe($item->adresse).'",'.
     	 '"'.sqlsafe($item->ville).'",'.
     	 '"'.sqlsafe($item->province).'",'.
     	 '"'.sqlsafe($item->pays).'",'.
     	 '"'.sqlsafe($item->codepostal).'",'.
     	 '"'.sqlsafe($item->telephone).'",'.
     	 '"'.sqlsafe($item->poste).'",'.
     	 '"'.sqlsafe($item->cellulaire).'",'.
     	 '"'.sqlsafe($item->teleavertisseur).'",'.
     	 '"'.sqlsafe($item->autretelephone).'",'.
     	 '"'.sqlsafe($item->telecopieur).'",'.
     	 '"'.sqlsafe($item->siteweb).'",'.
     	 '"'.sqlsafe($item->created).'"';
      
    exit();
   }
   break;
  default:
   message ('ERREUR: Format non reconnu <i>'.$format.'</i>');
 }
}


// AFFICHAGE DU CONTENU

function display_create_table()
{
 echo '
	<p>
	<form name="create_table" method="post" action="'.$_SERVER['PHP_SELF'].'">
	<b>La table <i>distrib_list</i> n\'existe pas dans la base de donnes.</b>
	<input type="hidden" name="action" value="create_table">
	<input type="submit" value="Crer la table">
	</form>
	</p>
      ';//
}

function display_results($result)
{
 echo '
      <hr>
      <form id="list" action="'.$_SERVER['PHP_SELF'].'" method="POST" style="display=inline">
       <input type="hidden" id="action" name="action" value="">
       <b>Nombre d\'inscriptions  la liste: '.mysql_num_rows($result).'</b>
       <table>
        <thead>
         <tr>
          <td width="1"><input id="checkall" type="checkbox" onClick="javascript:toggle_all()"></td>
          <td>Nom</td>
          <td>Courriel</td>
          <td>Tlphone</td>
          <td>Catgorie</td>
          <td>Date d\'inscription</td>
         </tr>
        </thead>
        <tbody>';
 $count=0;
 while ($liste=mysql_fetch_object($result))
  echo '
         <tr>
          <td><input id="checkbox" type="checkbox" name="id[]" value="'.$liste->id.'" onClick="javascript:if (!checked) checkall.checked=false;"></td>
          <td title="'.$liste->nom.' <'.$liste->courriel.'>'.iif($liste->telephone!='','
Tlphone: '.$liste->telephone.iif($liste->poste!='',' poste '.$liste->poste,''),'').iif($liste->adresse!='','
'.$liste->adresse.', '.$liste->ville.' ('.$liste->province.'), '.$liste->pays.', '.$liste->codepostal,'').iif($liste->commentaires!='','
'.$liste->commentaires,'').'">
              '.$liste->nom.'</td>
          <td><a href="mailto:'.$liste->courriel.'">'.$liste->courriel.'</a></td>
          <td>'.$liste->telephone.'</td>
          <td>'.$liste->categorie.'</td>
          <td>'.$liste->created.'</td>
         </tr>';
  echo '
        </tbody>
        <tfoot>
         <tr>
          <td colspan=6>
           <input type="submit" value="Effacer" onClick="javascript:action.value=\'confirm_delete\';">
           <input type="submit" value="Exporter" onClick="javascript:action.value=\'export_format\';">
          </td>
         </tr>
        </tfoot>
       </table>
      </form>';
// JAVASCRIPT CODE:
echo '
<script lang="javascript"><!--
function toggle_all() {
 var i;
 for(i=0;i<=list.checkbox.length;i++)
  list.checkbox[i].checked=list.checkall.checked;
}//--></script>';
}

function display_add_field()
{
 echo '<h3>Ajouter un champ personnalis</h3>
	<form name="add_field" action="'.$_SERVER['PHP_SELF'].'" method="post">
	 <input type="hidden" name="action" value="add_field">
	 Nom du champ : <input type="text" name="field_name" size="20" maxlength="20"><br>
	 Type: VARCHAR()  TEXT  <br>
TO BE CONTINUED...
	 <div id="varchar" style="display=none">
	  Nombre maximal de caractres : <input type="text" name="field_maxlen" size="4" maxlength="3"><br>
	 </div>
	 <input type="submit" value="Soumettre">
	</form>
      ';
}

function display_confirm_delete()
{
 $requete = 'SELECT * FROM distrib_list WHERE ';
 foreach ($_POST['id'] as $id) $requete .= 'id='.$id.' OR ';
 $requete .= '1=0 ORDER BY nom';
 $result = diesel_db_query($requete);
 if (!$result)
  echo $requete;
 else
 {
  echo '
   <form name="delete" action="'.$_SERVER['PHP_SELF'].'" method="POST">
    <input type="hidden" name="action" value="delete">
    <p><b>ATTENTION ! tes-vous certain de vouloir effacer '.iif(mysql_num_rows($result)==1,'l\'entre suivante','les '.mysql_num_rows($result).' entres suivantes').' ?</b></p>
    <p>
     <ul>';
  while ($item=mysql_fetch_object($result))
   echo '
      <li>'.$item->nom.' &lt;'.$item->courriel.'&gt;
      <input type="hidden" name="id[]" value="'.$item->id.'"></li>';
  echo '
     </ul>
    </p>
    <input type="submit" value="Confirmer">
    <input type="button" value="Annuler" onClick="javascript:history.back()">
   </form>';
 }
}

function display_export_format()
{
 echo '
  <form name="export" action="export.php" method="POST">
   <p><b>Slectionnez un format pour exporter les inscriptions slectionnes</b></p>
   <input type="hidden" name="action" value="export">';
 foreach($_POST['id'] as $id) echo '
   <input type="hidden" name="id[]" value="'.$id.'">';
 echo '
   <select name="format">
<!--    <option value="vcf" enabled="false">Carte de visite vCard-->
    <option value="csv" selected>Format texte CSV (Standard)
    <option value="csv_outlook">Format texte CSV (Outlook)
   </select><br>
<!--   <input type="radio" name="format" value="vcf" disabled>Carte de visite vCard<br>
   <input type="radio" name="format" value="csv" checked>Format texte CSV (Standard)<br>
   <input type="radio" name="format" value="csv_outlook">Format texte CSV (Outlook)<br>-->
   <input type="submit" value="Exporter">
   <input type="button" value="Termin" onClick="javascript:history.back()">
  </form>';
}

// PROCESS:

$action = null;
if (isset($_POST['action'])) $action = $_POST['action'];

function process_action()
{
 global $action;

 switch ($action)
 {
  case 'create_table':
        create_table();
        break;
  case 'confirm_delete':
  case 'export_format':
  	if (!isset($_POST['id']))
  	{
  	 message('ERREUR: Aucune entre slectionne');
  	 $action=null;
  	}
  	break;
  case 'delete';
  	action_delete();
  	break;
  default:
        if ($action) message('ERREUR: Action non reconnue: <i>'.$action.'</i>');
 }
}

process_action();

function diesel_content_dump()
{
 global $action;

	echo '
	 <h2>Administration de la liste</h2>';


 switch ($action)
 {
  case 'confirm_delete':
        display_confirm_delete();
  	break;
  case 'export_format':
  	display_export_format();
  	break;
  default:
        echo '
         <p>Dans cette section vous pouvez grer les inscriptions de la liste d\'envoi.</p>
	 <p><a href="index.php">Ajouter une inscription</a></p>';
  	$requete = 'SELECT * FROM distrib_list WHERE 1=1 ORDER BY '.@iif( isset($_POST['tri']), $_POST['tri'], 'created DESC');
	$resultat = diesel_db_query($requete);
	if (!$resultat)
	 display_create_table();
	else
	 display_results($resultat);
 }
}

diesel_display();

?>