<?php /*

Diesel 1.0 init script

diesel/system/init.php
Creation date/cr le: 10/12/2004
Written by/crit par Bigue Nique (BigueNique@yahoo.ca)
Copyright (C) 2004-2005, Fiat+/Lux Media
This file is part of the Diesel Project.
Ce fichier fait partie du projet Diesel.

*/

// Load configuration file
include ($DIESEL['CONFPATH'].'diesel.conf');

// Load phptools.php
include ($DIESEL['SYSTEMPATH'].'phptools.php');

// Load Debug services
include ($DIESEL['SYSTEMPATH'].'debug.php');
$DEBUG =& new debug();

// Load Diesel classes
include ($DIESEL['SYSTEMPATH'].'classes.php');

// Load the diesel registry
// The registry is intended to replace the $DIESEL array
$DIESEL['SYSCONF'] = new diesel_registry($DIESEL['SYSTEMPATH'].'registry.dat');
if (!$DIESEL['SYSCONF']->wake())
{



}

// Load database library
include ($DIESEL['SYSTEMPATH'].'db.php');

diesel_db_connect(); // Connect to the database


// Load user library
include ($DIESEL['SYSTEMPATH'].'user.php');

diesel_session_recall(); // Retrieve session data & authenticates if logged in


// Load language library
include ($DIESEL['SYSTEMPATH'].'lang.php');


// Load display library
include ($DIESEL['SYSTEMPATH'].'display.php');

?>