<?php /*

Diesel 1.0 debug class

debug.php
Creation date/cr le: 27/01/2005
Written by/crit par Bigue Nique (BigueNique@yahoo.ca)
Copyright (C) 2004, Fiat+/Lux Media
This file is part of the Diesel Project.
Ce fichier fait partie du projet Diesel.

Relies on phptools.php for function millitime();

*/

class debug {

	var $starttime;
	var $lines;

	function debug () { //constructor

	 $this->starttime = millitime();
	 unset ($this->lines);
	}

	function reset () {

	 $this->debug();
	}


	function output($out="", $mod='?', $fun='?', $lin='?') {

	 $this->lines[] =
	  Array(
	   'out' => $out,
	   'mod' => $mod,
	   'fun' => $fun,
	   'lin' => $lin,
	   'tim' => millitime()-$this->starttime
	  );
	}


	function html_dump() {

	 echo '<table class="debug"><thead><tr><tt class="debug" colspan=4>debug dump for '.$_SERVER['PHP_SELF'].'</tt></tr>';
	 echo '<tr><td>#</td><td>time</td><td>module::function::line</td><td>output</td></tr></thead>';
	 echo '<tbody class="debug">';
	 if (isset($this->lines))
	 foreach ($this->lines as $index => $line)
	  echo '<tr class="debug">'
	   .   ' <td class="debug-index">'
	   .   '  '.$index.''
	   .   ' </td>'
	   .   ' <td class="debug-time">'
	   .   '  '.$line['tim'].''
	   .   ' </td>'
	   .   ' <td class="debug-source">'
	   .   '  '.basename($line['mod']).'::'.$line['fun'].'::'.$line['lin'].''
	   .   ' </td>'
	   .   ' <td class="debug-output">'
	   .   '  '.$line['out'].''
	   .   ' </td>'
	  ;
	 echo '</tbody></table>';
	}

}
